Botan 2.19.5 Crypto and TLS for C&

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Botan::ECGDSA_PublicKey Class Reference

`#include <ecgdsa.h>`

Inheritance diagram for Botan::ECGDSA_PublicKey:

## Public Member Functions
std::string | algo_name () const override
AlgorithmIdentifier | algorithm_identifier () const override
bool | check_key (RandomNumberGenerator &rng, bool strong) const override
virtual std::unique_ptr< PK_Ops::Encryption > | create_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
virtual std::unique_ptr< PK_Ops::KEM_Encryption > | create_kem_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
std::unique_ptr< PK_Ops::Verification > | create_verification_op (const std::string &params, const std::string &provider) const override
virtual Signature_Format | default_x509_signature_format () const
std::vector< uint8_t > | DER_domain () const
const EC_Group & | domain () const
EC_Group_Encoding | domain_format () const
| ECGDSA_PublicKey (const AlgorithmIdentifier &alg_id, const std::vector< uint8_t > &key_bits)
| ECGDSA_PublicKey (const EC_Group &dom_par, const PointGFp &public_point)
size_t | estimated_strength () const override
std::string | fingerprint_public (const std::string &alg="SHA-256") const
virtual OID | get_oid () const
size_t | key_length () const override
size_t | message_part_size () const override
size_t | message_parts () const override
PointGFp::Compression_Type | point_encoding () const
std::vector< uint8_t > | public_key_bits () const override
const PointGFp & | public_point () const
void | set_parameter_encoding (EC_Group_Encoding enc)
void | set_point_encoding (PointGFp::Compression_Type enc)
std::vector< uint8_t > | subject_public_key () const

## Protected Member Functions
| ECGDSA_PublicKey ()=default

## Protected Attributes
EC_Group_Encoding | m_domain_encoding
EC_Group | m_domain_params
PointGFp::Compression_Type | m_point_encoding = PointGFp::UNCOMPRESSED
PointGFp | m_public_key

## Detailed Description

This class represents ECGDSA public keys.

Definition at line 18 of file ecgdsa.h.

## Constructor & Destructor Documentation

## ◆ ECGDSA_PublicKey() [1/3]

Botan::ECGDSA_PublicKey::ECGDSA_PublicKey | ( | const EC_Group & | dom_par,
|  | const PointGFp & | public_point
| ) |  |
| inline

Construct a public key from a given public point.

Parameters

  dom_par | the domain parameters associated with this key
  public_point | the public point defining this key

Definition at line 27 of file ecgdsa.h.

28 :
29 EC_PublicKey(dom_par, public_point) {}
Botan::EC_PublicKey::EC_PublicKey
EC_PublicKey()
Definition: ecc_key.h:111
Botan::EC_PublicKey::public_point
const PointGFp & public_point() const
Definition: ecc_key.h:57

## ◆ ECGDSA_PublicKey() [2/3]

Botan::ECGDSA_PublicKey::ECGDSA_PublicKey | ( | const AlgorithmIdentifier & | alg_id,
|  | const std::vector< uint8_t > & | key_bits
| ) |  |
| inline

Load a public key.

Parameters

  alg_id | the X.509 algorithm identifier
  key_bits | DER encoded public key bits

Definition at line 36 of file ecgdsa.h.

37 :
38 EC_PublicKey(alg_id, key_bits) {}

## ◆ ECGDSA_PublicKey() [3/3]

Botan::ECGDSA_PublicKey::ECGDSA_PublicKey | ( |  | ) |
| protected default

## Member Function Documentation

## ◆ algo_name()

std::string Botan::ECGDSA_PublicKey::algo_name | ( |  | ) | const
| inline override virtual

Get this keys algorithm name.

Returns
  this keys algorithm name ("ECGDSA")

Implements Botan::Public_Key.

Definition at line 44 of file ecgdsa.h.

44{ return "ECGDSA"; }

Referenced by Botan::ECGDSA_PrivateKey::create_signature_op(), and create_verification_op().

## ◆ algorithm_identifier()

AlgorithmIdentifier Botan::EC_PublicKey::algorithm_identifier | ( |  | ) | const
| override virtual inherited

Returns
  X.509 AlgorithmIdentifier for this key

Implements Botan::Public_Key.

Reimplemented in Botan::GOST_3410_PublicKey.

Definition at line 64 of file ecc_key.cpp.

65 {
66 return AlgorithmIdentifier(get_oid(), DER_domain());
67 }
Botan::EC_PublicKey::DER_domain
std::vector< uint8_t > DER_domain() const
Definition: ecc_key.h:90
Botan::Public_Key::get_oid
virtual OID get_oid() const
Definition: pk_keys.cpp:53

References Botan::EC_PublicKey::DER_domain(), and Botan::Public_Key::get_oid().

Referenced by Botan::GOST_3410_PrivateKey::pkcs8_algorithm_identifier().

## ◆ check_key()

bool Botan::EC_PublicKey::check_key | ( | RandomNumberGenerator & | rng,
|  | bool | strong
| ) |  | const
| override virtual inherited

Test the key values for consistency.

Parameters

  rng | rng to use
  strong | whether to perform strong and lengthy version of the test

Returns
  true if the test is passed

Implements Botan::Public_Key.

Reimplemented in Botan::ECDSA_PrivateKey, Botan::ECGDSA_PrivateKey, Botan::ECKCDSA_PrivateKey, and Botan::SM2_PrivateKey.

Definition at line 56 of file ecc_key.cpp.

58 {
59 return m_domain_params.verify_group(rng) &&
60 m_domain_params.verify_public_element(public_point());
61 }
Botan::EC_Group::verify_group
bool verify_group(RandomNumberGenerator &rng, bool strong=false) const
Definition: ec_group.cpp:727
Botan::EC_Group::verify_public_element
bool verify_public_element(const PointGFp &y) const
Definition: ec_group.cpp:704
Botan::EC_PublicKey::m_domain_params
EC_Group m_domain_params
Definition: ecc_key.h:114

References Botan::EC_PublicKey::m_domain_params, Botan::EC_PublicKey::public_point(), Botan::EC_Group::verify_group(), and Botan::EC_Group::verify_public_element().

## ◆ create_encryption_op()

std::unique_ptr< PK_Ops::Encryption > Botan::Public_Key::create_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::ElGamal_PublicKey, Botan::RSA_PublicKey, and Botan::SM2_PublicKey.

Definition at line 91 of file pk_keys.cpp.

94 {
95 throw Lookup_Error(algo_name() + " does not support encryption");
96 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Encryptor_EME::PK_Encryptor_EME().

## ◆ create_kem_encryption_op()

std::unique_ptr< PK_Ops::KEM_Encryption > Botan::Public_Key::create_kem_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::McEliece_PublicKey, and Botan::RSA_PublicKey.

Definition at line 99 of file pk_keys.cpp.

102 {
103 throw Lookup_Error(algo_name() + " does not support KEM encryption");
104 }

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_KEM_Encryptor::PK_KEM_Encryptor().

## ◆ create_verification_op()

std::unique_ptr< PK_Ops::Verification > Botan::ECGDSA_PublicKey::create_verification_op | ( | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a verification operation for this key/params or throw

Parameters

  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 137 of file ecgdsa.cpp.

139 {
140 if(provider == "base" || provider.empty())
141 return std::unique_ptr<PK_Ops::Verification>(new ECGDSA_Verification_Operation(*this, params));
142 throw Provider_Not_Found(algo_name(), provider);
143 }
Botan::ECGDSA_PublicKey::algo_name
std::string algo_name() const override
Definition: ecgdsa.h:44

References algo_name().

## ◆ default_x509_signature_format()

virtual Signature_Format Botan::Public_Key::default_x509_signature_format | ( |  | ) | const
| inline virtual inherited

Reimplemented in Botan::GOST_3410_PublicKey.

Definition at line 125 of file pk_keys.h.

126 {
127 return (this->message_parts() >= 2) ? DER_SEQUENCE : IEEE_1363;
128 }
Botan::Public_Key::message_parts
virtual size_t message_parts() const
Definition: pk_keys.h:112
Botan::DER_SEQUENCE
@ DER_SEQUENCE
Definition: pk_keys.h:23
Botan::IEEE_1363
@ IEEE_1363
Definition: pk_keys.h:23

References Botan::DER_SEQUENCE, and Botan::IEEE_1363.

Referenced by Botan::X509_Object::choose_sig_format(), and Botan::X509_Object::verify_signature().

## ◆ DER_domain()

std::vector< uint8_t > Botan::EC_PublicKey::DER_domain | ( |  | ) | const
| inline inherited

Return the DER encoding of this keys domain in whatever format is preset for this particular key

Definition at line 90 of file ecc_key.h.

91 { return domain().DER_encode(domain_format()); }
Botan::EC_Group::DER_encode
std::vector< uint8_t > DER_encode(EC_Group_Encoding form) const
Definition: ec_group.cpp:631
Botan::EC_PublicKey::domain
const EC_Group & domain() const
Definition: ecc_key.h:72
Botan::EC_PublicKey::domain_format
EC_Group_Encoding domain_format() const
Definition: ecc_key.h:97

Referenced by Botan::EC_PublicKey::algorithm_identifier().

## ◆ domain()

const EC_Group & Botan::EC_PublicKey::domain | ( |  | ) | const
| inline inherited

Get the domain parameters of this key.

Exceptions

  Invalid_State | is thrown if the domain parameters of this point are not set

Returns
  the domain parameters of this key

Definition at line 72 of file ecc_key.h.

72{ return m_domain_params; }

Referenced by Botan::GOST_3410_PublicKey::algo_name(), Botan::GOST_3410_PublicKey::algorithm_identifier(), botan_pubkey_sm2_compute_za(), Botan::EC_PrivateKey::EC_PrivateKey(), Botan::EC_PublicKey::EC_PublicKey(), Botan::GOST_3410_PublicKey::GOST_3410_PublicKey(), Botan::EC_PublicKey::key_length(), Botan::ECDSA_PublicKey::recovery_param(), and Botan::SM2_PrivateKey::SM2_PrivateKey().

## ◆ domain_format()

EC_Group_Encoding Botan::EC_PublicKey::domain_format | ( |  | ) | const
| inline inherited

Get the domain parameter encoding to be used when encoding this key.

Returns
  the encoding to use

Definition at line 97 of file ecc_key.h.

98 { return m_domain_encoding; }
Botan::EC_PublicKey::m_domain_encoding
EC_Group_Encoding m_domain_encoding
Definition: ecc_key.h:116

## ◆ estimated_strength()

size_t Botan::EC_PublicKey::estimated_strength | ( |  | ) | const
| override virtual inherited

Return the estimated strength of the underlying key against the best currently known attack. Note that this ignores anything but pure attacks against the key itself and do not take into account padding schemes, usage mistakes, etc which might reduce the strength. However it does suffice to provide an upper bound.

Returns
  estimated strength in bits

Implements Botan::Public_Key.

Definition at line 25 of file ecc_key.cpp.

26 {
27 return ecp_work_factor(key_length());
28 }
Botan::EC_PublicKey::key_length
size_t key_length() const override
Definition: ecc_key.cpp:20
Botan::ecp_work_factor
size_t ecp_work_factor(size_t bits)
Definition: workfactor.cpp:14

References Botan::ecp_work_factor(), and Botan::EC_PublicKey::key_length().

## ◆ fingerprint_public()

std::string Botan::Public_Key::fingerprint_public | ( | const std::string & | alg = `"SHA-256"` | ) | const
| inherited

Returns
  Hash of the subject public key

Definition at line 77 of file pk_keys.cpp.

78 {
79 return create_hex_fingerprint(subject_public_key(), hash_algo);
80 }
Botan::Public_Key::subject_public_key
std::vector< uint8_t > subject_public_key() const
Definition: pk_keys.cpp:38
Botan::create_hex_fingerprint
std::string create_hex_fingerprint(const uint8_t bits[], size_t bits_len, const std::string &hash_name)
Definition: pk_keys.cpp:17
hash_algo
AlgorithmIdentifier hash_algo
Definition: x509_obj.cpp:22

References Botan::create_hex_fingerprint(), hash_algo, and Botan::Public_Key::subject_public_key().

## ◆ get_oid()

OID Botan::Public_Key::get_oid | ( |  | ) | const
| virtual inherited

Get the OID of the underlying public key scheme.

Returns
  OID of the public key scheme

Reimplemented in Botan::XMSS_WOTS_Addressed_PublicKey.

Definition at line 53 of file pk_keys.cpp.

54 {
55 const OID o = OIDS::str2oid_or_empty(algo_name());
56 if(o.empty())
57 throw Lookup_Error("PK algo " + algo_name() + " has no defined OIDs");
58 return o;
59 }
Botan::OIDS::str2oid_or_empty
BOTAN_UNSTABLE_API OID str2oid_or_empty(const std::string &name)
Definition: oids.cpp:116

References Botan::Public_Key::algo_name(), Botan::OID::empty(), and Botan::OIDS::str2oid_or_empty().

Referenced by Botan::TPM_PrivateKey::algorithm_identifier(), Botan::Curve25519_PublicKey::algorithm_identifier(), Botan::DL_Scheme_PublicKey::algorithm_identifier(), Botan::EC_PublicKey::algorithm_identifier(), Botan::Ed25519_PublicKey::algorithm_identifier(), Botan::GOST_3410_PublicKey::algorithm_identifier(), Botan::McEliece_PublicKey::algorithm_identifier(), Botan::RSA_PublicKey::algorithm_identifier(), and Botan::XMSS_WOTS_Addressed_PublicKey::get_oid().

## ◆ key_length()

size_t Botan::EC_PublicKey::key_length | ( |  | ) | const
| override virtual inherited

Return an integer value best approximating the length of the primary security parameter. For example for RSA this will be the size of the modulus, for ECDSA the size of the ECC group, and for McEliece the size of the code will be returned.

Implements Botan::Public_Key.

Definition at line 20 of file ecc_key.cpp.

21 {
22 return domain().get_p_bits();
23 }
Botan::EC_Group::get_p_bits
size_t get_p_bits() const
Definition: ec_group.cpp:472

References Botan::EC_PublicKey::domain(), and Botan::EC_Group::get_p_bits().

Referenced by Botan::EC_PublicKey::estimated_strength().

## ◆ message_part_size()

size_t Botan::ECGDSA_PublicKey::message_part_size | ( |  | ) | const
| inline override virtual

Returns how large each of the message parts refered to by message_parts() is

This function is public but applications should have few reasons to ever call this.

Returns
  size of the message parts in bits

Reimplemented from Botan::Public_Key.

Definition at line 48 of file ecgdsa.h.

49 { return domain().get_order().bytes(); }
Botan::BigInt::bytes
size_t bytes() const
Definition: bigint.cpp:289
Botan::EC_Group::get_order
const BigInt & get_order() const
Definition: ec_group.cpp:512

## ◆ message_parts()

size_t Botan::ECGDSA_PublicKey::message_parts | ( |  | ) | const
| inline override virtual

Returns more than 1 if the output of this algorithm (ciphertext, signature) should be treated as more than one value. This is used for algorithms like DSA and ECDSA, where the (r,s) output pair can be encoded as either a plain binary list or a TLV tagged DER encoding depending on the protocol.

This function is public but applications should have few reasons to ever call this.

Returns
  number of message parts

Reimplemented from Botan::Public_Key.

Definition at line 46 of file ecgdsa.h.

46{ return 2; }

## ◆ point_encoding()

PointGFp::Compression_Type Botan::EC_PublicKey::point_encoding | ( |  | ) | const
| inline inherited

Get the point encoding method to be used when encoding this key.

Returns
  the encoding to use

Definition at line 104 of file ecc_key.h.

105 { return m_point_encoding; }
Botan::EC_PublicKey::m_point_encoding
PointGFp::Compression_Type m_point_encoding
Definition: ecc_key.h:117

Referenced by Botan::EC_PublicKey::public_key_bits().

## ◆ public_key_bits()

std::vector< uint8_t > Botan::EC_PublicKey::public_key_bits | ( |  | ) | const
| override virtual inherited

Returns
  BER encoded public key bits

Implements Botan::Public_Key.

Reimplemented in Botan::GOST_3410_PublicKey.

Definition at line 69 of file ecc_key.cpp.

70 {
71 return public_point().encode(point_encoding());
72 }
Botan::EC_PublicKey::point_encoding
PointGFp::Compression_Type point_encoding() const
Definition: ecc_key.h:104
Botan::PointGFp::encode
std::vector< uint8_t > encode(PointGFp::Compression_Type format) const
Definition: point_gfp.cpp:601

References Botan::PointGFp::encode(), Botan::EC_PublicKey::point_encoding(), and Botan::EC_PublicKey::public_point().

Referenced by Botan::EC_PrivateKey::EC_PrivateKey().

## ◆ public_point()

const PointGFp & Botan::EC_PublicKey::public_point | ( |  | ) | const
| inline inherited

Get the public point of this key.

Exceptions

  Invalid_State | is thrown if the domain parameters of this point are not set

Returns
  the public point of this key

Definition at line 57 of file ecc_key.h.

57{ return m_public_key; }
Botan::EC_PublicKey::m_public_key
PointGFp m_public_key
Definition: ecc_key.h:115

Referenced by botan_pubkey_sm2_compute_za(), Botan::EC_PublicKey::check_key(), Botan::ECDSA_PrivateKey::check_key(), Botan::ECGDSA_PrivateKey::check_key(), Botan::ECKCDSA_PrivateKey::check_key(), Botan::SM2_PrivateKey::check_key(), Botan::EC_PublicKey::EC_PublicKey(), Botan::EC_PublicKey::public_key_bits(), Botan::GOST_3410_PublicKey::public_key_bits(), and Botan::ECDSA_PublicKey::recovery_param().

## ◆ set_parameter_encoding()

void Botan::EC_PublicKey::set_parameter_encoding | ( | EC_Group_Encoding | enc | ) |
| inherited

Set the domain parameter encoding to be used when encoding this key.

Parameters

  enc | the encoding to use

Definition at line 84 of file ecc_key.cpp.

85 {
86 if(form != EC_DOMPAR_ENC_EXPLICIT &&
87 form != EC_DOMPAR_ENC_IMPLICITCA &&
88 form != EC_DOMPAR_ENC_OID)
89 throw Invalid_Argument("Invalid encoding form for EC-key object specified");
90
91 if((form == EC_DOMPAR_ENC_OID) && (m_domain_params.get_curve_oid().empty()))
92 throw Invalid_Argument("Invalid encoding form OID specified for "
93 "EC-key object whose corresponding domain "
94 "parameters are without oid");
95
96 m_domain_encoding = form;
97 }
Botan::EC_Group::get_curve_oid
const OID & get_curve_oid() const
Definition: ec_group.cpp:557
Botan::OID::empty
bool empty() const
Definition: asn1_obj.h:232
Botan::EC_DOMPAR_ENC_EXPLICIT
@ EC_DOMPAR_ENC_EXPLICIT
Definition: ec_group.h:24
Botan::EC_DOMPAR_ENC_OID
@ EC_DOMPAR_ENC_OID
Definition: ec_group.h:26
Botan::EC_DOMPAR_ENC_IMPLICITCA
@ EC_DOMPAR_ENC_IMPLICITCA
Definition: ec_group.h:25

References Botan::EC_DOMPAR_ENC_EXPLICIT, Botan::EC_DOMPAR_ENC_IMPLICITCA, Botan::EC_DOMPAR_ENC_OID, Botan::OID::empty(), Botan::EC_Group::get_curve_oid(), Botan::EC_PublicKey::m_domain_encoding, and Botan::EC_PublicKey::m_domain_params.

## ◆ set_point_encoding()

void Botan::EC_PublicKey::set_point_encoding | ( | PointGFp::Compression_Type | enc | ) |
| inherited

Set the point encoding method to be used when encoding this key.

Parameters

  enc | the encoding to use

Definition at line 74 of file ecc_key.cpp.

75 {
76 if(enc != PointGFp::COMPRESSED &&
77 enc != PointGFp::UNCOMPRESSED &&
78 enc != PointGFp::HYBRID)
79 throw Invalid_Argument("Invalid point encoding for EC_PublicKey");
80
81 m_point_encoding = enc;
82 }
Botan::PointGFp::UNCOMPRESSED
@ UNCOMPRESSED
Definition: point_gfp.h:51
Botan::PointGFp::COMPRESSED
@ COMPRESSED
Definition: point_gfp.h:52
Botan::PointGFp::HYBRID
@ HYBRID
Definition: point_gfp.h:53

References Botan::PointGFp::COMPRESSED, Botan::PointGFp::HYBRID, Botan::EC_PublicKey::m_point_encoding, and Botan::PointGFp::UNCOMPRESSED.

## ◆ subject_public_key()

std::vector< uint8_t > Botan::Public_Key::subject_public_key | ( |  | ) | const
| inherited

Returns
  X.509 subject key encoding for this key object

Definition at line 38 of file pk_keys.cpp.

39 {
40 std::vector<uint8_t> output;
41
42 DER_Encoder(output).start_cons(SEQUENCE)
43 .encode(algorithm_identifier())
44 .encode(public_key_bits(), BIT_STRING)
45 .end_cons();
46
47 return output;
48 }
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0
Botan::Public_Key::public_key_bits
virtual std::vector< uint8_t > public_key_bits() const =0
Botan::BIT_STRING
@ BIT_STRING
Definition: asn1_obj.h:37
Botan::SEQUENCE
@ SEQUENCE
Definition: asn1_obj.h:42

References Botan::Public_Key::algorithm_identifier(), Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::Public_Key::public_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::X509::BER_encode(), Botan::PKCS10_Request::create(), Botan::Public_Key::fingerprint_public(), and Botan::X509::PEM_encode().

## Member Data Documentation

## ◆ m_domain_encoding

EC_Group_Encoding Botan::EC_PublicKey::m_domain_encoding
| protected inherited

Definition at line 116 of file ecc_key.h.

Referenced by Botan::EC_PrivateKey::EC_PrivateKey(), Botan::EC_PublicKey::EC_PublicKey(), and Botan::EC_PublicKey::set_parameter_encoding().

## ◆ m_domain_params

EC_Group Botan::EC_PublicKey::m_domain_params
| protected inherited

Definition at line 114 of file ecc_key.h.

Referenced by Botan::EC_PublicKey::check_key(), Botan::EC_PrivateKey::EC_PrivateKey(), Botan::GOST_3410_PrivateKey::GOST_3410_PrivateKey(), Botan::GOST_3410_PublicKey::GOST_3410_PublicKey(), and Botan::EC_PublicKey::set_parameter_encoding().

## ◆ m_point_encoding

PointGFp::Compression_Type Botan::EC_PublicKey::m_point_encoding = PointGFp::UNCOMPRESSED
| protected inherited

Definition at line 117 of file ecc_key.h.

Referenced by Botan::EC_PublicKey::set_point_encoding().

## ◆ m_public_key

PointGFp Botan::EC_PublicKey::m_public_key
| protected inherited

Definition at line 115 of file ecc_key.h.

Referenced by Botan::EC_PrivateKey::EC_PrivateKey(), Botan::GOST_3410_PublicKey::GOST_3410_PublicKey(), and Botan::EC_PrivateKey::private_key_bits().

The documentation for this class was generated from the following files:

- src/lib/pubkey/ecgdsa/ecgdsa.h
- src/lib/pubkey/ecgdsa/ecgdsa.cpp